﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using System.Configuration;
using System.Net;
using System.IO;
using System.Text.RegularExpressions;
using System.Data;
using System.Data.OleDb;
using Geekees.App.SinaFeed.Lib;

namespace Geekees.App.SinaFeed.Web
{
    public partial class _Default : System.Web.UI.Page
    {
        protected bool CleanDB
        {
            get
            {
                object o = Request.QueryString["CleanDB"];
                return o == null ? false : ((string)o).ToLower() == "true";
            }
        }

        protected string SinaUserId
        {
            get
            {
                object o = Request.QueryString["SinaUserId"];
                if( o == null )
                    throw new Exception("SinaUserId is a must!");

                return (string)o;
            }
        }

        protected string TweetEncoding
        {
            get
            {
                object o = Request.QueryString["Encoding"];
                return o == null ? "UTF-8" : (string)o;
            }
        }

        protected bool UseOriginalImage
        {
            get
            {
                object o = Request.QueryString["UseOriginalImage"];
                return o == null ? true : bool.Parse((string)o);
            }
        }

        protected bool UseFullTitle
        {
            get
            {
                object o = Request.QueryString["UseFullTitle"];
                return o == null ? true : bool.Parse((string)o);
            }
        }

        protected bool RemoveQuotation
        {
            get
            {
                object o = Request.QueryString["RemoveQuotation"];
                return o == null ? true : bool.Parse((string)o);
            }
        }

        protected int TitleMaxLength
        {
            get
            {
                object o = Request.QueryString["TitleMaxLength"];
                return o == null ? 140 : int.Parse((string)o);
            }
        }

        protected int RssMaxItemCount
        {
            get
            {
                object o = Request.QueryString["RssMaxItemCount"];
                return o == null ? 100 : int.Parse((string)o);
            }
        }

        protected string AuthCode
        {
            get
            {
                object o = Request.QueryString["AuthCode"];
                return o == null ? "" : (string)o;
            }
        }

        protected string AuthCodeConfig
        {
            get
            {
                object o = ConfigurationManager.AppSettings["AuthCodeConfig"];
                return o == null ? "" : (string)o;
            }
        }

        protected string AllowedUserIds
        {
            get
            {
                object o = ConfigurationManager.AppSettings["AllowedUserIds"];
                return o == null ? "" : (string)o;
            }
        }

        protected bool AttachImageToEnclosure
        {
            get
            {
                object o = Request.QueryString["AttachImageToEnclosure"];
                return o == null ? true : bool.Parse((string)o);
            }
        }

        protected bool AttachImageToTitle
        {
            get
            {
                object o = Request.QueryString["AttachImageToTitle"];
                return o == null ? false : bool.Parse((string)o);
            }
        }

        protected bool AttachImageToDescription
        {
            get
            {
                object o = Request.QueryString["AttachImageToDescription"];
                return o == null ? false : bool.Parse((string)o);
            }
        }

		protected bool AttachOriginalMblogToRT
		{
			get
			{
				object o = Request.QueryString["AttachOriginalMblogToRT"];
				return o == null ? true : bool.Parse( (string)o );
			}
		}

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected override void Render(HtmlTextWriter writer)
        {
            GenerateRSSFeed();
        }
        
        protected void GenerateRSSFeed()
        {
            Authentication();

            SinaFeedManager manager = new SinaFeedManager();

            if (CleanDB)
                manager.CleanDB();

            manager.SinaUserId = this.SinaUserId;
            manager.TweetEncoding = this.TweetEncoding;
            manager.UseOriginalImage = this.UseOriginalImage;
            manager.UseFullTitle = this.UseFullTitle;
            manager.RemoveQuotaion = this.RemoveQuotation;
            manager.TitleMaxLength = this.TitleMaxLength;
            manager.RssMaxItemCount = this.RssMaxItemCount;
            manager.AttachImageToEnclosure = this.AttachImageToEnclosure;
            manager.AttachImageToTitle = this.AttachImageToTitle;
            manager.AttachImageToDescription = this.AttachImageToDescription;
			manager.AttachOriginalMblogToRT = this.AttachOriginalMblogToRT;

            manager.GetSinaTweets();

            Response.Clear();
            Response.Charset = this.TweetEncoding;
            Response.ContentEncoding = Encoding.GetEncoding(this.TweetEncoding);
            Response.ContentType = "text/xml";

            manager.WriteRSSFeed(Response.OutputStream);

            Response.Flush();
            Response.End();
        }

        private void Authentication()
        {
            if (this.AuthCodeConfig != string.Empty)
            {
                if (this.AuthCode != this.AuthCodeConfig )
                    throw new Exception("Authentication Failed!");
            }

            if (this.AllowedUserIds != string.Empty)
            {
                string[] tokens = this.AllowedUserIds.Split(',');
                if( !tokens.Contains( this.SinaUserId ) )
                    throw new Exception( string.Format( "The Sina id {0} is not allowed!", this.SinaUserId ) );
            }
        }
    }
}
